"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = __importDefault(require("classnames"));
var react_1 = __importStar(require("react"));
var react_dom_1 = require("react-dom");
var modal_1 = __importDefault(require("../modal"));
var utils_1 = require("../utils");
var ActionSheet = /** @class */ (function (_super) {
    __extends(ActionSheet, _super);
    function ActionSheet(props) {
        var _this = _super.call(this, props) || this;
        _this._container = document.createElement('div');
        _this._container.classList.add('_x_actionsheet_');
        document.body.appendChild(_this._container);
        return _this;
    }
    ActionSheet.prototype.componentWillUnmount = function () {
        document.body.removeChild(this._container);
    };
    ActionSheet.prototype._content = function () {
        var _a = this.props, title = _a.title, visible = _a.visible, className = _a.className, onClose = _a.onClose, onClick = _a.onClick, items = _a.items, closeText = _a.closeText, otherProps = __rest(_a, ["title", "visible", "className", "onClose", "onClick", "items", "closeText"]);
        if (!Array.isArray(items)) {
            throw new TypeError('ActionSheet 的 items 必须是个数组');
        }
        var composeClassName = classnames_1.default('x-actionsheet', className);
        return (react_1.default.createElement(modal_1.default, __assign({ visible: visible, onBgClick: onClose, className: composeClassName }, otherProps),
            !!title && react_1.default.createElement("h1", { className: "x-actionsheet__title" }, title),
            react_1.default.createElement("div", { className: "x-actionsheet__list" }, items.map(function (item, index) {
                var name = item.name, className = item.className, otherProps = __rest(item, ["name", "className"]);
                var composeClassName = classnames_1.default('x-actionsheet__button', className);
                return (react_1.default.createElement("div", { className: "x-actionsheet__item", key: index },
                    react_1.default.createElement(utils_1.Report, __assign({}, otherProps, { key: index, className: composeClassName, onClick: function () {
                            onClick && onClick(item);
                        } }), name)));
            })),
            !!closeText && (react_1.default.createElement("a", { href: "javascript:;", className: "x-actionsheet__closebtn", onClick: onClose }, closeText))));
    };
    ActionSheet.prototype.render = function () {
        if (this._container) {
            return react_dom_1.createPortal(this._content(), this._container);
        }
        return null;
    };
    return ActionSheet;
}(react_1.Component));
exports.default = ActionSheet;
