"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = __importDefault(require("classnames"));
var history_1 = require("history");
var react_1 = __importDefault(require("react"));
var react_dom_1 = require("react-dom");
var button_1 = __importDefault(require("../button"));
var AlertCom = /** @class */ (function (_super) {
    __extends(AlertCom, _super);
    function AlertCom() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AlertCom.prototype.render = function () {
        var _a = this.props, title = _a.title, desc = _a.desc, btns = _a.btns, onClose = _a.onClose, otherProps = __rest(_a, ["title", "desc", "btns", "onClose"]);
        return (react_1.default.createElement("div", __assign({ className: "x-alert__inner" }, otherProps),
            react_1.default.createElement("div", { className: "x-alert__body" },
                !!title && react_1.default.createElement("h1", null, title),
                react_1.default.createElement("p", { className: title ? '' : 'no-title' }, desc)),
            react_1.default.createElement("div", { className: "x-alert__btns" }, !!btns &&
                btns.map(function (btn, index) {
                    var name = btn.name, onClick = btn.onClick, className = btn.className, _a = btn.type, type = _a === void 0 ? 'primary' : _a, otherProps = __rest(btn, ["name", "onClick", "className", "type"]);
                    var composeClassName = classnames_1.default('auto-ui-alert__btns-btn', className);
                    return (react_1.default.createElement(button_1.default, __assign({ className: composeClassName, onClick: function (e) {
                            onClick && onClick(e);
                            onClose && onClose(e);
                        }, key: index, type: type }, otherProps), name));
                }))));
    };
    return AlertCom;
}(react_1.default.Component));
function Alert(params, callback) {
    var composeParams = params;
    if (typeof params === 'string') {
        composeParams = {
            title: params
        };
    }
    var className = composeParams.className, btns = composeParams.btns;
    var div = document.createElement('div');
    div.classList.add('x-alert', 'x-alert--show');
    className && div.classList.add(className);
    document.body.appendChild(div);
    var browserHistory = history_1.createBrowserHistory();
    var unListen = browserHistory.listen(function (location, action) {
        close();
    });
    function close() {
        div.classList.remove('x-alert--show');
        div.classList.add('x-alert--hide');
        var timeNumber = 200;
        setTimeout(function () {
            react_dom_1.unmountComponentAtNode(div);
            if (div && div.parentNode) {
                div.parentNode.removeChild(div);
            }
            callback && callback();
            unListen();
        }, timeNumber);
    }
    btns = btns ? btns : [{ name: '确定' }];
    react_dom_1.render(react_dom_1.createPortal(react_1.default.createElement(AlertCom, __assign({ btns: btns }, composeParams, { onClose: close })), div), div);
    return {
        close: close
    };
}
Alert.async = function (params) { return __awaiter(_this, void 0, void 0, function () {
    return __generator(this, function (_a) {
        return [2 /*return*/, new Promise(function (resolve) {
                Alert(params, function () {
                    resolve();
                });
            })];
    });
}); };
exports.default = Alert;
