"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = __importDefault(require("classnames"));
var react_1 = __importStar(require("react"));
var CellRow = function (props) {
    var className = props.className, arrow = props.arrow, onClick = props.onClick, activeable = props.activeable, children = props.children, value = props.value, otherProps = __rest(props, ["className", "arrow", "onClick", "activeable", "children", "value"]);
    var composeClassName = classnames_1.default('x-cell__row', className, {
        'x-cell--activeable': onClick || activeable,
        'x-cell--arrow': arrow
    });
    return (react_1.default.createElement("div", __assign({}, otherProps, { className: composeClassName, onClick: function () {
            onClick && onClick(value);
        } }), children));
};
var Cell = function (props) {
    var arrow = props.arrow, indentLine = props.indentLine, className = props.className, children = props.children, onClick = props.onClick, otherProps = __rest(props, ["arrow", "indentLine", "className", "children", "onClick"]);
    var composeClassName = classnames_1.default('x-cell', className, {
        'x-cell--indent-line': indentLine
    });
    var composeChildren = [];
    if (children) {
        composeChildren = composeChildren.concat(children);
    }
    return (react_1.default.createElement("section", __assign({}, otherProps, { className: composeClassName }), composeChildren.map(function (children, index) {
        if (children && children.type === CellRow) {
            return react_1.cloneElement(children, {
                key: index,
                arrow: arrow || children.props.arrow,
                onClick: onClick || children.props.onClick
            });
        }
        return children;
    })));
};
Cell.Row = CellRow;
exports.default = Cell;
