"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = __importDefault(require("classnames"));
var react_1 = __importDefault(require("react"));
var react_dom_1 = require("react-dom");
var modal_1 = __importDefault(require("../modal"));
var Dialog = /** @class */ (function (_super) {
    __extends(Dialog, _super);
    function Dialog(props) {
        var _this = _super.call(this, props) || this;
        _this.div = document.createElement('div');
        _this.div.classList.add('_x_dialog_');
        document.body.appendChild(_this.div);
        return _this;
    }
    Dialog.prototype.componentWillUnmount = function () {
        if (this.div && this.div.parentNode) {
            this.div.parentNode.removeChild(this.div);
        }
    };
    Dialog.prototype._content = function () {
        var _a = this.props, className = _a.className, height = _a.height, visible = _a.visible, children = _a.children, onBgClick = _a.onBgClick, otherProps = __rest(_a, ["className", "height", "visible", "children", "onBgClick"]);
        var composeClassName = classnames_1.default('x-dialog', className);
        return (react_1.default.createElement(modal_1.default, __assign({}, otherProps, { visible: visible, height: height, onBgClick: onBgClick, className: composeClassName }),
            react_1.default.createElement("div", { className: "x-dialog__inner" }, children)));
    };
    Dialog.prototype.render = function () {
        return react_dom_1.createPortal(this._content(), this.div);
    };
    return Dialog;
}(react_1.default.Component));
exports.default = Dialog;
var Scroller = function (props) {
    var className = props.className, children = props.children;
    var composeClassName = classnames_1.default('x-dialog__scroller', className);
    return (react_1.default.createElement("div", { className: composeClassName },
        react_1.default.createElement("div", { className: "x-dialog__inscroller" }, children)));
};
Dialog.Scroller = Scroller;
