"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = __importDefault(require("classnames"));
var react_1 = __importDefault(require("react"));
var Input = /** @class */ (function (_super) {
    __extends(Input, _super);
    function Input() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Input.prototype.render = function () {
        var _a = this.props, type = _a.type, className = _a.className, addonBefore = _a.addonBefore, addonAfter = _a.addonAfter, error = _a.error, multi = _a.multi, disabled = _a.disabled, value = _a.value, onChange = _a.onChange, otherProps = __rest(_a, ["type", "className", "addonBefore", "addonAfter", "error", "multi", "disabled", "value", "onChange"]);
        var composeClassName = classnames_1.default('x-input', {
            'x-input--error': error,
            'x-input--multi': multi,
            'x-input--disabled': disabled
        }, className);
        if (multi) {
            return (react_1.default.createElement("div", { className: composeClassName },
                !!addonBefore && (react_1.default.createElement("div", { className: "x-input__addon-before" }, addonBefore)),
                react_1.default.createElement("textarea", __assign({}, otherProps, { className: "x-input__ipt", value: value, onChange: onChange })),
                !!addonAfter && (react_1.default.createElement("div", { className: "x-input__addon-after" }, addonAfter))));
        }
        return (react_1.default.createElement("div", { className: composeClassName },
            !!addonBefore && (react_1.default.createElement("div", { className: "x-input__addon-before" }, addonBefore)),
            react_1.default.createElement("input", __assign({}, otherProps, { disabled: disabled, className: "x-input__ipt", value: value, onChange: onChange, type: type || 'text' })),
            !!addonAfter && (react_1.default.createElement("div", { className: "x-input__addon-after" }, addonAfter))));
    };
    return Input;
}(react_1.default.Component));
exports.default = Input;
