import { ComponentClass, FC, MouseEventHandler, ReactNode, UIEventHandler } from 'react';
export interface LayoutProps {
    className?: string;
    [otherProps: string]: any;
}
declare const Layout: FC<LayoutProps> & {
    Header: FC<LayoutHeaderProps>;
    Footer: FC<LayoutFooterProps>;
    Body: ComponentClass<LayoutBodyProps>;
};
export interface LayoutBodyProps {
    loading?: boolean;
    errorInfo?: ReactNode;
    className?: string;
    onScroll?: UIEventHandler<HTMLDivElement>;
    onReachBottom?: {
        content?: ReactNode;
        handler: () => void;
        disable?: boolean;
    };
}
export interface LayoutFooterProps {
    className?: string;
    [otherProps: string]: any;
}
export interface LayoutHeaderProps {
    className?: string;
    children?: ReactNode;
    ghost?: boolean;
    addonBefore?: ReactNode;
    onBackClick?: MouseEventHandler<HTMLAnchorElement>;
    onCloseClick?: MouseEventHandler<HTMLAnchorElement>;
    title?: string;
    addonAfter?: ReactNode;
    addonBottom?: ReactNode;
    [otherProps: string]: any;
}
export default Layout;
