"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = __importDefault(require("classnames"));
var react_1 = __importDefault(require("react"));
var Modal = /** @class */ (function (_super) {
    __extends(Modal, _super);
    function Modal(props) {
        var _this = _super.call(this, props) || this;
        _this._onAnimationEnd = function (e) {
            if (_this.state.ani !== 'leave') {
                return;
            }
            _this.setState({
                ani: 'init',
                visible: false
            });
        };
        _this.state = {
            visible: false,
            ani: 'init'
        };
        return _this;
    }
    Modal.prototype.componentDidMount = function () {
        if (this.props.visible) {
            this._enter();
        }
    };
    Modal.prototype.UNSAFE_componentWillReceiveProps = function (nextProps) {
        if (!this.props.visible && nextProps.visible) {
            this._enter();
        }
        else if (this.props.visible && !nextProps.visible) {
            this._leave();
        }
    };
    Modal.prototype._enter = function () {
        var _this = this;
        this.setState({
            visible: true
        });
        setTimeout(function (e) {
            _this.setState({
                ani: 'enter'
            });
        });
        var focusdom = document.querySelector(':focus');
        if (focusdom) {
            focusdom.blur();
        }
    };
    Modal.prototype._leave = function () {
        this.setState({
            ani: 'leave'
        });
    };
    Modal.prototype.render = function () {
        var _a = this.props, className = _a.className, height = _a.height, onBgClick = _a.onBgClick, visible = _a.visible, otherProps = __rest(_a, ["className", "height", "onBgClick", "visible"]);
        var css = classnames_1.default('x-modal', "x-modal--" + this.state.ani, className);
        var composeHeight = height || 0;
        return (react_1.default.createElement("div", __assign({}, otherProps, { className: css, style: {
                display: this.state.visible ? '' : 'none'
            } }),
            react_1.default.createElement("div", { className: "x-modal__bg", onClick: onBgClick }),
            react_1.default.createElement("div", { className: "x-modal__inner", style: {
                    height: composeHeight ? composeHeight + '%' : 'auto'
                }, onAnimationEnd: this._onAnimationEnd }, this.props.children)));
    };
    return Modal;
}(react_1.default.Component));
exports.default = Modal;
