"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = __importDefault(require("classnames"));
var react_1 = __importDefault(require("react"));
var react_dom_1 = require("react-dom");
var modal_1 = __importDefault(require("../modal"));
var Popup = /** @class */ (function (_super) {
    __extends(Popup, _super);
    function Popup(props) {
        var _this = _super.call(this, props) || this;
        _this._container = null;
        var local = _this.props.local;
        // 在当前节点中展示
        if (local) {
            return _this;
        }
        _this._container = document.createElement('div');
        _this._container.classList.add('_x_popup_');
        document.body.appendChild(_this._container);
        return _this;
    }
    Popup.prototype.componentWillUnmount = function () {
        this._container && document.body.removeChild(this._container);
    };
    Popup.prototype._content = function () {
        var _a = this.props, className = _a.className, top = _a.top, onBgClick = _a.onBgClick, height = _a.height, visible = _a.visible, noPadding = _a.noPadding, children = _a.children, otherProps = __rest(_a, ["className", "top", "onBgClick", "height", "visible", "noPadding", "children"]);
        var composeClassName = classnames_1.default('x-popup', {
            'x-popup--top': top
        }, className);
        var composeChildren = [];
        if (children) {
            composeChildren = composeChildren.concat(children);
        }
        var hasScrollChildren = false;
        composeChildren.forEach(function (res) {
            if (res.type === Scroller && !hasScrollChildren) {
                hasScrollChildren = true;
            }
        });
        var innercss = classnames_1.default('x-popup__inner', {
            'x-popup--no-scroll': hasScrollChildren,
            'x-popup--no-padding': noPadding
        });
        // DOM没有local这个属性，需要删除
        delete otherProps.local;
        return (react_1.default.createElement(modal_1.default, __assign({}, otherProps, { visible: visible, height: height, onBgClick: onBgClick, className: composeClassName }),
            react_1.default.createElement("div", { className: innercss }, children)));
    };
    Popup.prototype.render = function () {
        if (this._container) {
            return react_dom_1.createPortal(this._content(), this._container);
        }
        else if (this.props.local) {
            return this._content();
        }
        return null;
    };
    return Popup;
}(react_1.default.Component));
exports.default = Popup;
var Scroller = function (props) {
    var className = props.className, children = props.children, otherProps = __rest(props, ["className", "children"]);
    var composeClassName = classnames_1.default('x-popup__scroller', className);
    return (react_1.default.createElement("div", __assign({}, otherProps, { className: composeClassName }),
        react_1.default.createElement("div", { className: "x-popup__inscroller" }, children)));
};
Popup.Scroller = Scroller;
