"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = __importDefault(require("classnames"));
var react_1 = __importDefault(require("react"));
var utils_1 = require("../utils");
var Radio = function (props) {
    var checked = props.checked, disabled = props.disabled, className = props.className, text = props.text, onChange = props.onChange, value = props.value, otherProps = __rest(props, ["checked", "disabled", "className", "text", "onChange", "value"]);
    var composeClassName = classnames_1.default('x-radio', {
        'x-radio__checked': checked,
        'x-radio__disabled': disabled
    }, className);
    return (react_1.default.createElement(utils_1.Report, __assign({}, otherProps, { className: composeClassName, onClick: function () {
            if (disabled) {
                return;
            }
            onChange && onChange(value, text);
        } }),
        react_1.default.createElement("i", { className: "x-radio__icon" },
            react_1.default.createElement("sup", { className: "x-radio__tick" })),
        !!text && react_1.default.createElement("span", { className: "x-radio__text" }, text)));
};
exports.default = Radio;
