/// <reference path="../../types/custom.d.ts" />
import { Component } from 'react';
import '../__libs/dateFormat';
export interface TimePickerProps {
    data: [{
        day: Date;
        times: [];
    }];
    defaultDay: Date;
    format: [];
    interval: number;
    onChange: (date: Date) => void;
    className?: string;
}
export interface TimePickerState {
    props: TimePickerProps;
    days: any;
    times: any;
    HH: any;
    MM: any;
    format: any;
    dayValue: any;
    HHValue: any;
    MMValue: any;
    HHIndex: number;
    MMIndex: number;
    dayIndex: number;
}
export default class TimePicker extends Component<TimePickerProps, TimePickerState> {
    static getDerivedStateFromProps(props: TimePickerProps, state: TimePickerState): {
        times: {
            HH: never[];
        };
        HH: never[];
        MM: never;
        dayIndex: number;
        dayValue: any;
        HHIndex: number;
        HHValue: never;
        MMIndex: number;
        MMValue: never;
        props: {
            data: [{
                day: Date;
                times: [];
            }];
            defaultDay: Date;
            format: [];
            interval: number;
            onChange: (date: Date) => void;
            className?: string | undefined;
        };
        days: any;
    } | null;
    dayId: string;
    HHId: string;
    MMId: string;
    realScrollRowHeight: number;
    iScrollDay: any;
    iScrollDayY: any;
    iScrollHH: any;
    iScrollHHY: any;
    iScrollMM: any;
    iScrollMMY: any;
    constructor(props: TimePickerProps);
    componentDidMount(): void;
    componentWillUnmount(): void;
    componentDidUpdate(props: TimePickerProps): void;
    refresh(): void;
    reset(): void;
    getTime(): Date;
    setTime(t: any): void;
    initScrolls: () => void;
    refreshScrolls: () => void;
    scrollEndCalc: (scroll: any, type: string) => void;
    onChange: () => void;
    destroyScrolls: () => void;
    renderDayList(): JSX.Element;
    renderHHList(): JSX.Element;
    renderMMList(): JSX.Element | null;
    render(): JSX.Element;
}
